



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>fdisk分区硬盘并shell脚本自动化</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">fdisk分区硬盘并shell脚本自动化</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 21:57:04 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>最近工作需要用到对硬盘进行shell脚本自动化分区和mount的操作，google了一些资料，下面做个总结。</p>
<p>如果硬盘没有进行分区（逻辑分区或者扩展分区，关于两者概念，自行google），我们将无法将使用该硬盘来进行读写。我们要使用一块硬盘需要进行下面三步：</p>
<ol><li>将该硬盘进行分区；</li>
<li>对分区进行格式化；</li>
<li>将分区mount到系统某个目录，便可以访问。</li></ol>
<p>本笔记会着重讲一下第一步中涉及的fdisk分区功能以及如何来使用shell进行自动化处理，过程也会涉及后面两步操作的简单说明。</p>
<h2>fdisk对硬盘进行分区</h2>
<p>fdisk是linux系统提供的硬盘分区工具。关于fdisk的详细说明可以自行google或者man fdisk。下面我们直接说明操作步骤。</p>
<p>先查看一下当前系统有哪些硬盘：</p>
<div>
<pre class="prettyprint linenums">ubuntu@i-idh5qfpk:~$ ls /dev | grep sd<br />
sda<br />
sda1<br />
sdb<br />
sdc<br />
sdd<br />
sdd1</pre>
</div>
<p>我们就选择/dev/sdc进行下手吧。通过fdisk -l查看一下该硬盘的分区表：</p>
<div>
<pre class="prettyprint linenums">ubuntu@i-idh5qfpk:~$ sudo fdisk -l /dev/sdc

Disk /dev/sdc: 10.7 GB,  bytes<br />
 heads,  sectors/track,  cylinders, total  sectors<br />
Units = sectors of  *  =  bytes<br />
Sector size (logical/physical):  bytes /  bytes<br />
I/O size (minimum/optimal):  bytes /  bytes<br />
Disk identifier: 0xacb1d488

   Device Boot      Start         End      Blocks   Id  System</pre>
</div>
<p>通过上面的信息，我们可以看到该硬盘总共有10.7GB，但是分区表为空（命令最后面的输出信息即是分区表信息）。下面我们通过运行fdisk命令来对该硬盘进行交互式的分区操作。输入fdisk /dev/sdc命令之后，会提示你进行什么操作，如果不清楚的话，可以输入m然后回车查看操作说明。如下所示，</p>
<div>
<pre class="prettyprint linenums">ubuntu@i-idh5qfpk:~$ sudo fdisk /dev/sdc

Command (m for help): m<br />
Command action<br />
   a   toggle a bootable flag<br />
   b   edit bsd disklabel<br />
   c   toggle the dos compatibility flag<br />
   d   delete a partition<br />
   l   list known partition types<br />
   m   print this menu<br />
   n   add a new partition<br />
   o   create a new empty DOS partition table<br />
   p   print the partition table<br />
   q   quit without saving changes<br />
   s   create a new empty Sun disklabel<br />
   t   change a partition's system id<br />
   u   change display/entry units<br />
   v   verify the partition table<br />
   w   write table to disk and exit<br />
   x   extra functionality (experts only)

Command (m for help): </pre>
</div>
<p>我们要新建分区，输入n，然后回车。提示该硬盘当前有0个主要分区（primary）、0个扩展分区（extended），可以创建4个分区，然后让我们选择创建主要分区还是扩展分区。输入p并回车（或者直接回车），选择创建主要分区。</p>
<div>
<pre class="prettyprint linenums">Command (m for help): n<br />
Partition type:<br />
   p   primary ( primary,  extended,  free)<br />
   e   extended<br />
Select (default p): p</pre>
</div>
<p>然后提示输入分区编号（只能1到4，默认为1），我们输入1并回车，</p>
<div>
<pre class="prettyprint linenums">Partition number (-, default ): </pre>
</div>
<p>输入分区的开始扇区，我们直接回车采用默认配置，</p>
<div>
<pre class="prettyprint linenums">First sector (-, default ):<br />
Using default value </pre>
</div>
<p>输入分区的结束扇区，也直接回车采用默认配置，</p>
<div>
<pre class="prettyprint linenums">Last sector, +sectors or +size{K,M,G} (-, default ):<br />
Using default value </pre>
</div>
<p>此时我们的分区建好了，但还需要输入w并回车来进行保存。</p>
<div>
<pre class="prettyprint linenums">Command (m for help): w<br />
The partition table has been altered!

Calling ioctl() to re-read partition table.<br />
Syncing disks.</pre>
</div>
<p>该硬盘的分区建立完毕，通过fdisk -l查看一下最后的效果，</p>
<div>
<pre class="prettyprint linenums">ubuntu@i-idh5qfpk:~$ sudo  fdisk -l /dev/sdc

Disk /dev/sdc: 10.7 GB,  bytes<br />
 heads,  sectors/track,  cylinders, total  sectors<br />
Units = sectors of  *  =  bytes<br />
Sector size (logical/physical):  bytes /  bytes<br />
I/O size (minimum/optimal):  bytes /  bytes<br />
Disk identifier: 0xacb1d488

   Device Boot      Start         End      Blocks   Id  System<br />
 /dev/sdc1                         Linux</pre>
</div>
<p>我们新建的分区就是/dev/sdc1。接下来，我们对该分区进行格式化，</p>
<div>
<pre class="prettyprint linenums">ubuntu@i-idh5qfpk:~$ sudo mkfs -t ext3 /dev/sdc1<br />
mke2fs 1.42. (-Feb-)<br />
Discarding device blocks: done<br />
Filesystem label=<br />
OS type: Linux<br />
Block size= (log=)<br />
Fragment size= (log=)<br />
Stride= blocks, Stripe width= blocks<br />
 inodes,  blocks<br />
 blocks (5.00%) reserved for the super user<br />
First data block=<br />
Maximum filesystem blocks=<br />
 block groups<br />
 blocks per group,  fragments per group<br />
 inodes per group<br />
Superblock backups stored on blocks:<br />
    , , , , , , , 

Allocating group tables: done<br />
Writing inode tables: done<br />
Creating journal ( blocks): done<br />
Writing superblocks and filesystem accounting information: done </pre>
</div>
<p>格式化完毕。然后将该分区挂载到目录/mysdc，</p>
<div>
<pre class="prettyprint linenums">ubuntu@i-idh5qfpk:~$ sudo mkdir -p /mysdc<br />
ubuntu@i-idh5qfpk:~$ sudo mount /dev/sdc1 /mysdc</pre>
</div>
<p>通过df命令查看一下。</p>
<div>
<pre class="prettyprint linenums">ubuntu@i-idh5qfpk:~$ sudo df -k<br />
Filesystem     1K-blocks     Used Available Use% Mounted on<br />
/dev/sda1             % /<br />
none                                       % /sys/fs/cgroup<br />
udev                           % /dev<br />
tmpfs                          % /run<br />
none                                 % /run/lock<br />
none                        % /run/shm<br />
none                             % /run/user<br />
/dev/sdc1                 % /mysdc</pre>
</div>
<p>完成。</p>
<h2>shell脚本自动化</h2>
<p>上面我们是通过fdisk工具交互式地进行对硬盘进行分区的。那我们如何将其写成shell脚本自动化。回顾一下，我们刚刚交互式分区时输入的操作序列，然后自己阅读下面的脚本吧，太简单了，没什么好讲的。</p>
<div>
<pre class="prettyprint linenums">#!/bin/bash

echo "n<br />
p

w<br />
" | fdisk /dev/sdc &amp;&amp; mkfs -t /dev/sdc1</pre>
</div>
<p><em>注意：1和w之间是两个空行。</em></p>
<h2>删除分区</h2>
<p>同样通过fdisk来删除分区，操作如下，不细说了，</p>
<div>
<pre class="prettyprint linenums">ubuntu@i-idh5qfpk:~$ sudo fdisk /dev/sdc

Command (m for help): d<br />
Selected partition 

Command (m for help): w<br />
The partition table has been altered!

Calling ioctl() to re-read partition table.<br />
Syncing disks.</pre>
</div>
<p>shell自动化脚本请参考创建分区的shell脚本自行编写。</p>
<p>(done)</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rql376qo.html">使用OAuth、Identity创建WebApi认证接口供客户端调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/495xk4e8.html">&lbrack;转&rsqb;CSS 类名的单词连字符：下划线还是横杠？</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8my6w08.html">PC-BSD 9&period;2 发布，基于 FreeBSD 9&period;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okkl0p9.html">VB6 GDI&plus; 入门教程&lbrack;5&rsqb; 基础绘图小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wek2lq.html">理解position 绝对定位和相对定位</a>
		</li>
						<li><a href="https://www.batexi.com/a/96or45j9.html">hdu5032 Always Cook Mushroom</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v6pym8.html">第一次写博客，关于前端开发deMVC在js中的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge1o308.html">用PowerMockito来mock私有方法（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkwpwj8.html">Oracle单表的简单查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geywxz8.html">SSH深度历险（八） 剖析SSH核心原理&plus;Spring依赖注入的三种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me3nnrq.html">&lbrack;Swift&rsqb;LeetCode888&period; 公平的糖果交换 &vert; Fair Candy Swap</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyywwrgq.html">self study 权限 permission</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjmzw59.html">Matplotlib学习---用matplotlib画散点图，气泡图（scatter plot&comma; bubble chart）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o5dve8.html">PHP添加Memcached扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvevo7y9.html">re模块逐步进阶</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm1jn09.html">POSTGRESQL 创建表结构、修改字段、导入导出数据库（支持CSV）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v5kx5q.html">PHPDragon设计结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pkvxnq.html">K组翻转链表 &amp;&num;183&semi; Reverse Nodes in k-Group</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjkl4jq.html">去除eclipse的validating</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve7xvj9.html">激活Win10内置版Linux （ubuntu）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/1q26mno9.html">编写一个Java应用程序，该应用程序包括2个类：Print类和主类E。Print 类里有一个方法output&lpar;&rpar;功能是输出100 ~ 999之间的所有水仙花数（各位数字的 立方和等于这个三位数本身，如&colon; 371 &equals; 33 &plus; 73 &plus; 13。）在主类E的main方法中来 测试类Print</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlxn36q.html">0011《SQL必知必会》笔记07 数据的插入、更新和删除</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyogyg8.html">android 利用Path&period;cubicTo 画 贝塞尔曲线</a>
			</li>
						<li><a href="https://www.batexi.com/a/m964l0v8.html">C&plus;&plus;变量和函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/390140m8.html">linux &sol;proc&sol;sys&sol;fs&sol;file-nr &sol;proc&sol;sys&sol;fs&sol;file-max &sol;etc&sol;security&sol;limits&period;conf 三者的关联</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlxpeeq.html">理解 OpenStack Swift （1）：OpenStack &plus; 三节点Swift 集群&plus; HAProxy &plus; UCARP 安装和配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o2lx59.html">我要好offer之 二叉树大总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8exx1xq.html">Buffer Overflow Study</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyolv28.html">多年前写的一个ASP&period;NET网站管理系统，到现在有些公司在用</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zlpv3q.html">转&colon; 使用Eclipse的Working Set&comma;界面清爽多了</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
